﻿package  {	
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.utils.getTimer;
	import com.greensock.*;
	import com.greensock.easing.*;
	import flash.net.SharedObject;
	
	public class main extends MovieClip {
		public var lolsMc:MovieClip;
		public var lolsArray:Array;
		
		public var score:int = 0;
		public var bestScore:int = 0;
		public var lols:int = 0;
		public var lolsInARow:int = 0;
		public var amountOfLols:int = 0;
		public var distance:int = 67;
		public var theSeconds:int = 0;
		public var shakeCounter:int = 0;
		
		
		public var startTime:Number = 0;
		public var theTime:Number = 0;
		public var gameMilliSeconds:Number = 10000;
		
		public var clickable:Boolean = true;
		
		public var scoreTxt:scoreMc;
		public var tb:timebar;
		public var restartButton:restartMc;
		public var bigScore:bigScoreMc;
		public var playAgainButton:playAgainMc;
		
		public var so:SharedObject;
		
		public function main() {
			this.addEventListener(Event.ADDED_TO_STAGE, this.init);
		}
		
		public function init(event:Event){
			this.removeEventListener(Event.ADDED_TO_STAGE, this.init);
			this.bg.gotoAndStop(1);
			this.startMc.sb.addEventListener(MouseEvent.MOUSE_DOWN, this.md);
		}
		
		public function md(event:MouseEvent){
			this.startGame();
			this.startMc.sb.removeEventListener(MouseEvent.MOUSE_DOWN, this.md);
		}
		
		public function startGame(){
			this.ls1();
			this.sound1.gotoAndStop(1);
			this.sound2.gotoAndStop(1);
			
			this.startMc.visible = false;
			this.lolsMc = new MovieClip();
			this.lolsMc.x = 40;
			this.lolsMc.y = 52;
			
			
			
			this.scoreTxt = new scoreMc();
			this.scoreTxt.x = 40;
			this.scoreTxt.y = 433;
			
			this.score = 0;
			this.scoreTxt.txt.text = "" + this.score;
			
			this.tb = new timebar();
			this.tb.x = 28;
			this.tb.y = 20;
			
			this.restartButton = new restartMc();
			this.restartButton.x = 550;
			this.restartButton.y = 450;
			
			this.restartButton.addEventListener(MouseEvent.MOUSE_DOWN, this.playAgain);
			
			this.addChild(this.scoreTxt);
			this.addChild(this.tb);
			this.addChild(this.restartButton);
			this.addChild(this.lolsMc);
			
			this.playAgainButton = new playAgainMc();
			this.playAgainButton.x = 320;
			this.playAgainButton.y = 390;
			
			this.playAgainButton.addEventListener(MouseEvent.MOUSE_DOWN, this.playAgain);
			
			this.bigScore = new bigScoreMc();
			this.bigScore.x = 315;
			this.bigScore.y = 190;
			
			this.bigScore.visible = false;
			this.playAgainButton.visible = false;
			
			this.addChild(this.playAgainButton);
			this.addChild(this.bigScore);
			
			this.lolsArray = [];
			
			for(var i:int = 0; i<101; i++){
				var nt:tile;
				if(i<38){
					nt = new tile(this,i,true);
				}else{
					nt = new tile(this,i,false);
				}
				this.lolsArray.push(nt);
				this.lolsMc.addChild(nt);
			}
			
			this.startTime = getTimer();
			this.addEventListener(Event.ENTER_FRAME, this.oef);
		}
		
		public function playAgain(event:MouseEvent){
			this.bigScore.visible = false;
			this.playAgainButton.visible = false;
			for(var j:int = 0; j< 101 ;j++){
				this.lolsMc.removeChild(this.lolsArray[j]);
			}
			this.lolsMc.visible = true;
			this.tb.visible = true;
			this.restartButton.visible = true;
			this.scoreTxt.visible = true;
			this.score = 0;
			this.scoreTxt.txt.text = "" + this.score;
			this.tb.tb.scaleX = 1;
			
			this.lolsArray = [];
			
			for(var i:int = 0; i<101; i++){
				var nt:tile;
				if(i<38){
					nt = new tile(this,i,true);
				}else{
					nt = new tile(this,i,false);
				}
				this.lolsArray.push(nt);
				this.lolsMc.addChild(nt);
			}
			
			this.startTime = getTimer();
			this.addEventListener(Event.ENTER_FRAME, this.oef);
		}
		
		public function checkTile(nr_p){
			var hit:int = 0;
			for(var i:int = nr_p+1; i< 101 ;i++){
				if(this.lolsArray[i].hitTestObject(this.lolsArray[nr_p])){
					hit++;
				}
			}
			if(hit == 0){
				this.score++;
				this.scoreTxt.txt.text = "" + this.score;
				var rnd1:int = Math.floor(Math.random()*6)+1;
				if(this.bg.currentFrame != rnd1){
					this.bg.gotoAndStop(rnd1);
				}else{
					if(this.bg.currentFrame != this.bg.totalFrames){
						this.bg.gotoAndStop(rnd1+1);
					}else{
						this.bg.gotoAndStop(1);
					}
				}
				this.lolsArray[nr_p].removeClip();
				this.clickable = false;
				for(var j:int = 0; j< 101 ;j++){
					this.lolsArray[j].rotate90();
				}
				this.sound1.play();
				TweenLite.to(this, .19,{onComplete:this.clickAbleAgain});
			}else{
				this.sound2.play();
				this.shakeIt();
			}
		}
		
		public function shakeIt(){
			this.shakeCounter = 0;
			this.addEventListener(Event.ENTER_FRAME, this.oefShake);
		}
		
		public function oefShake(event:Event){
			this.shakeCounter++;
			if(this.shakeCounter == 1){
				this.x = -2;
				this.y = 2;
			}else if(this.shakeCounter == 2){
				this.x = 0;
				this.y = 1;
			}else if(this.shakeCounter == 3){
				this.x = 2;
				this.y = 1;
			}else if(this.shakeCounter == 4){
				this.x = 0;
				this.y = 0;
				this.removeEventListener(Event.ENTER_FRAME, this.oefShake);
			}
		}
		
		public function clickAbleAgain(){
			this.clickable = true;
		}
		
		public function oef(event:Event){
			this.theTime = this.gameMilliSeconds -  (getTimer() - this.startTime);
			
			if(this.theTime >= 0){
				this.theSeconds = Math.ceil(this.theTime/this.gameMilliSeconds);
			}else{
				this.theSeconds = 0;
				this.removeEventListener(Event.ENTER_FRAME, this.oef);
				this.gameOver();
			}
			
			this.tb.tb.scaleX = this.theTime/this.gameMilliSeconds;
			
		}
		
		public function gameOver(){
			this.lolsMc.visible = false;
			this.scoreTxt.visible = false;
			this.tb.visible = false;
			this.restartButton.visible = false;
			
			this.bigScore.txt1.text = "" + this.score;
			
			if(this.score>this.bestScore){
				this.bestScore = this.score;
				this.ls2();
			}
			
			this.bigScore.txt2.text = "" + this.bestScore;
			
			this.bigScore.visible = true;
			this.playAgainButton.visible = true;
		}
		
		public function ls1(){
			this.so=SharedObject.getLocal("lol");
			if(this.so.data.it=="there"){
				this.bestScore = this.so.data.bscr;				
			}else{				
				this.so.data.bscr = 0;
				this.so.data.it="there";
			}
			this.so.flush();
		}
		
		public function ls2(){
			this.so=SharedObject.getLocal("lol");
			this.so.data.bscr = this.bestScore;
			this.so.flush();
		}
		
		
	}
	
}
