﻿package  {	
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import com.greensock.*;
	import com.greensock.easing.*;
	
	
	public class tile extends MovieClip {
		public var mr:MovieClip;
		public var nr:int = 0;
		public var rot:int = 0;
		public var lOrO:int = 0;
		public var isActive:Boolean = true;
		public var aBoolean:Boolean = false;
		
		public function tile(mr_p:MovieClip, nr_p:int, bool_p:Boolean) {
			this.mr = mr_p;
			this.nr = nr_p;
			this.aBoolean = bool_p;
			
			this.rot = Math.floor(Math.random()*4);
			this.lOrO = Math.floor(Math.random()*2);
			this.addEventListener(Event.ADDED_TO_STAGE, this.init);				
		}
		
		public function placeTile(nr_p){
			
			if(nr_p<8){
				this.y = 45;
				this.x = 45 + nr_p * 67;
			}else if(nr_p>7 && nr_p<15){				
				this.y = 112;
				this.x = 45 + 34 + (nr_p-8) * 67;
			}else if(nr_p>14 && nr_p<23){
				this.y = 179;
				this.x = 45 + (nr_p-15) * 67;
			}else if(nr_p>22 && nr_p<30){
				this.y = 246;
				this.x = 45 + 34 + (nr_p-23) * 67;
			}else if(nr_p>29 && nr_p<38){
				this.y = 313;
				this.x = 45 + (nr_p - 30) * 67;
			}			
		}
		
		public function init(event:Event){
			this.gotoAndStop(this.lOrO+1);
			this.rotation = this.rot*90;
			trace(this.rotation);
			this.addEventListener(MouseEvent.MOUSE_DOWN, this.md);
			if(this.aBoolean){
				this.placeTile(this.nr);
			}else{
				this.placeTile(Math.floor(Math.random()*38));
			}
		}
		
		public function md(event:MouseEvent){
			if(this.mr.clickable){
				this.mr.checkTile(this.nr);
			}
		}
		
		public function rotate90(){
			if(this.lOrO == 1){
				TweenLite.to(this, .18, {rotation:this.rotation+89,ease:Circ.easeOut,onComplete:this.rotateComplete});
				this.rot++
				if(this.rot>3){
					this.rot = 0;
				}
			}
		}
		
		public function removeClip(){
			this.isActive = false;
			this.mouseEnabled = false;
			this.removeEventListener(MouseEvent.MOUSE_DOWN, this.md);
			var st:int = Math.floor(Math.random()*4);
			if(st==0){
				TweenLite.to(this, 2, {x:-1400,onComplete:this.removeComplete});
			}else if(st==1){
				TweenLite.to(this, 2, {x:1400,onComplete:this.removeComplete});
			}else if(st==2){
				TweenLite.to(this, 2, {y:-1400,onComplete:this.removeComplete});
			}else if(st==3){
				TweenLite.to(this, 2, {y:1400,onComplete:this.removeComplete});
			}
		}
		
		public function removeComplete(){
			alpha:0;
		}
		
		public function rotateComplete(){
			
			this.rotation++;
		}
	}
	
}
